$kind=$args[0]
$sep=$args[1]
$ar=$args[2]
$noopt=$args[3]
$comment=$args[4]
$optimisepdf=[Environment]::GetEnvironmentVariable('optimisepdf')
$process = Get-Process -Id $pid
echo "compilebroszury: kind=$kind, sep=$sep, ar=$ar"
$source='SP'
[System.Console]::OutputEncoding=[System.Text.Encoding]::UTF8
$host.ui.RawUI.WindowTitle = "broszury $source$kind$sep$ar first pass $comment"
echo "lualatex -interaction=nonstopmode --jobname=broszury$kind$sep$ar broszury.tex"
$process.PriorityClass = 'Idle'
lualatex -interaction=nonstopmode --jobname=broszury$kind$sep$ar broszury.tex
$process.PriorityClass = 'Normal'
sleep 3
$host.ui.RawUI.WindowTitle = "broszury $source$kind$sep$ar second pass $comment"
$process.PriorityClass = 'Idle'
lualatex --jobname=broszury$kind$sep$ar broszury.tex
$process.PriorityClass = 'Normal'
$host.ui.RawUI.WindowTitle = "compilation of broszury Spiewnika $source$kind$sep$ar $comment ended"
if(-not($noopt -match "o") -and $optimisepdf -and $optimisepdf -eq 1){
$host.ui.RawUI.WindowTitle = "Wait for broszury $source$kind$sep$ar on Mutex $comment"
  $mtx = New-Object System.Threading.Mutex($false, "AcrobatOptimizationMutex")
    If ($mtx.WaitOne(86400000)) {
      $host.ui.RawUI.WindowTitle = "optimization broszury $source$kind$sep$ar $comment"
      echo "Optymalizacja broszury$kind$sep$ar.pdf"
      $Optimizer = Start-Process -Wait -FilePath ".\autohotkey.ahk" -ArgumentList "broszury$kind$sep$ar.pdf" -passthru
#      Wait-Process -InputObject $Optimizer -ea Silentlycontinue
      sleep 5
      $Optimizer = Get-Process -name Acrobat -ea Silentlycontinue
      if($Optimizer -ne $null){Wait-Process -InputObject $Optimizer}
      echo "Koniec optymalizacji broszury$kind$sep$ar.pdf"
      $host.ui.RawUI.WindowTitle = "ended optimization broszury $source$kind$sep$ar $comment"
      [void]$mtx.ReleaseMutex()
    } else {
      echo "AcrobatOptimizationMutex przeterminowany"
      pause
    }
  $mtx.Dispose()
}
New-Item -ea SilentlyContinue broszury$kind$sep$ar.done
exit
