$kind=$args[0]
if ($kind.length -gt 1 -and $kind.substring(0,2) -eq 'oo') {
  $kind=$kind.remove(0,2)
  $noopt='o'
} else {
  $noopt=''
}
if ($kind.length -gt 1 -and $kind.substring(0,2) -eq 'bb') {
  $kind=$kind.remove(0,2)
  $booklettag='b'
} elseif ($kind.length -gt 0 -and $kind.substring(0,1) -eq 'b') {
  $kind=$kind.remove(0,1)
  $booklettag='b'
} else {
  $booklettag=''
}
if ($kind.length -gt 1 -and $kind.substring(0,2) -eq 'xx') {
  $kind=$kind.remove(0,2)
  $kindtag='x'
} elseif ($kind.length -gt 0 -and $kind.substring(0,1) -eq 'x') {
  $kind=""
  $kindtag='x'
} else {
  $kindtag=''
}
$sep=$args[1]
$ar=$args[2]
$comment=$args[3]
$restrict=''
$optimisepdf=[Environment]::GetEnvironmentVariable('optimisepdf')
$process = Get-Process -Id $pid
	echo "if((get-process -Id $PID -ea Silentlycontinue) -ne `$null){ Write-Host `" waiting for SP$kind$sep$ar$restrict...`" -NoNewLine;wait-process -ID $PID;Write-Host `" SP$kind$sep$ar$restrict ready`"}else{Write-Host `" SP$kind$sep$ar$restrict ready`"}" >> .\waitprocesses.ps1

#
# waiting so that there are not too many jobs running
#
$laststartedjobs=1000
$startedjobs=$(Get-ChildItem -Path ./ -filter *.started | Measure-Object -Property Directory| %{$_.Count})
while($startedjobs -ne '' -and $startedjobs -gt 20){
  if($startedjobs -ne $laststartedjobs){
    Write-Host "$startedjobs uruchomionych prac. Czekamy..."
    $host.ui.RawUI.WindowTitle = "$startedjobs started jobs. $kind$sep$ar$restrict is waiting..."
  }
  sleep 10
  $laststartedjobs=$startedjobs
  $startedjobs=$(Get-ChildItem -Path ./ -filter *.started | Measure-Object -Property Directory| %{$_.Count})
}
New-Item $kind$sep$ar$restrict.started

# if Acrobat is working, wait for stop
  if((get-process -Name Acrobat -ea Silentlycontinue) -ne $null){
    Write-Host "Prosimy, zamknij Acrobata. Czekamy..."
    get-process -Name Acrobat | wait-process }


function compile3pass{
	echo "compile3pass: kind=$kind, restrict=$restrict, booklettag=$booklettag, sep=$sep, ar=$ar"
	$source='SP'
	Set-PSDebug -Trace 0
	if((Test-Path $source''include.tex)){dir $source''include.tex}
		
	echo ""
	
	[System.Console]::OutputEncoding=[System.Text.Encoding]::UTF8
	$host.ui.RawUI.WindowTitle = "$source$kind$sep$ar$restrict prepare $comment"
	
	echo "awk -v sf=$source -v sd=$source$kind$sep$ar$restrict -f .\extractinclude.awk $source.tex"
	$SPinclude=start -Passthru -NoNewWindow powershell "awk -v sf=$source -v sd=$source$kind$sep$ar$restrict -f .\extractinclude.awk $source.tex"
	$SPinclude|Wait-process
	
	$host.ui.RawUI.WindowTitle = "$source$kind$sep$ar$restrict first pass $comment"
	echo "lualatex -interaction=nonstopmode --jobname=$source$kind$sep$ar$restrict $source''include.tex"
	$process.PriorityClass = 'Idle'
	lualatex -interaction=nonstopmode --jobname=$source$kind$sep$ar$restrict $source''include.tex
	$process.PriorityClass = 'Normal'
	sleep 3
	echo ".\sortixuni.ps1 $kind $sep $ar$restrict"
	.\sortixuni.ps1 $kind $sep $ar$restrict
	sleep 3
	echo "texindy -C utf8 -L polish $source$kind$sep$ar$restrict.idx"
	texindy -C utf8 -L polish $source$kind$sep$ar$restrict.idx
	
	sleep 3
	$host.ui.RawUI.WindowTitle = "$source$kind$sep$ar$restrict second pass $comment"
	echo "lualatex -interaction=nonstopmode --jobname=$source$kind$sep$ar$restrict $source''include.tex"
	$process.PriorityClass = 'Idle'
	lualatex -interaction=nonstopmode --jobname=$source$kind$sep$ar$restrict $source''include.tex
	$process.PriorityClass = 'Normal'
	sleep 3
	echo ".\sortixuni.ps1 $kind $sep $ar$restrict"
	.\sortixuni.ps1 $kind $sep $ar$restrict
	sleep 3
	echo "texindy -C utf8 -L polish $source$kind$sep$ar$restrict.idx"
	texindy -C utf8 -L polish $source$kind$sep$ar$restrict.idx
	
	sleep 3
	$host.ui.RawUI.WindowTitle = "$source$kind$sep$ar$restrict third pass $comment"
	echo "lualatex --jobname=$source$kind$sep$ar$restrict $source''include.tex"
	$process.PriorityClass = 'Idle'
	lualatex --jobname=$source$kind$sep$ar$restrict $source''include.tex
	
	grep "Hfootnote[.]" $source$kind$sep$ar$restrict.log
	if($LASTEXITCODE -eq 0){
	  $host.ui.RawUI.WindowTitle = "Footnotes error in $source$kind$sep$ar$restrict.log $comment"
	  echo "Cosik niedobrze z przypisami!"
	  pause
	}
	
	grep "unreferenced" $source$kind$sep$ar$restrict.log
	if($LASTEXITCODE -eq 0){
	  $host.ui.RawUI.WindowTitle = "References error in $source$kind$sep$ar$restrict.log $comment"
	  echo "Cosik niedobrze z linkami!"
	  pause
	}
	
	$process.PriorityClass = 'Normal'
	#del $source''include.tex
	sleep 3
	echo "rmdir -R $source$kind$sep$ar$restrict"
	rmdir -R $source$kind$sep$ar$restrict
	$host.ui.RawUI.WindowTitle = "$source$kind$sep$ar$restrict ended $comment"
	echo "Koniec trzyprzebiegowej kompilacji Spiewnika $source$kind$sep$ar$restrict"
	
	if(-not($noopt -match "o") -and $optimisepdf -and $optimisepdf -eq 1 -and ($restrict -ne '!booklet')){
	  $mtx = New-Object System.Threading.Mutex($false, "AcrobatOptimizationMutex")
	  $host.ui.RawUI.WindowTitle = "Wait for $source$kind$sep$ar$restrict on Mutex $comment"
	    If ($mtx.WaitOne(86400000)) {
	      $host.ui.RawUI.WindowTitle = "optimization $source$kind$sep$ar$restrict $comment"
	      echo "Optymalizacja $source$kind$sep$ar$restrict.pdf"
	      $Optimizer = Start-Process -Wait -FilePath ".\autohotkey.ahk" -ArgumentList "$source$kind$sep$ar$restrict.pdf" -passthru
#      	      Wait-Process -InputObject $Optimizer -ea Silentlycontinue
	      sleep 5
	      $Optimizer = Get-Process -name Acrobat -ea Silentlycontinue
	      if($Optimizer -ne $null){Wait-Process -InputObject $Optimizer}
	      echo "Koniec optymalizacji $source$kind$sep$ar$restrict.pdf"
	      $host.ui.RawUI.WindowTitle = "ended optimization $source$kind$sep$ar$restrict $comment"
	      [void]$mtx.ReleaseMutex()
	    } else {
	      echo "AcrobatOptimizationMutex przeterminowany"
	      pause
	    }
	  $mtx.Dispose()
	}
	New-Item -ea SilentlyContinue $source$kind$sep$ar$restrict.done
}

compile3pass

if(-not($kind -match "kikosq" -or $kind -match "tab34" -or $kind -match "-mono" -or $kind -match "-layers") -and $kindtag -ne "x"){
  sleep 3
  if($booklettag -eq "b" -or $kind -match "-alpha"){
    $restrict='!booklet'
    compile3pass
    $restrict=''
  }
  sleep 3
  echo "Startujemy sklad broszur dla $source$kind$sep$ar $comment"
  $host.ui.RawUI.WindowTitle = "ended $source$kind$sep$ar $comment, starting broszury"
  echo ".\compile-broszuryuni.ps1 '$kind' '$sep' '$ar' '$comment'"
  .\compile-broszuryuni.ps1 "$kind" "$sep" "$ar" "$noopt" "$comment"
  if($booklettag -eq "b" -or $kind -match "-alpha"){
    $restrict='!booklet'
    del SP$source$kind$sep$ar$restrict.*
    $restrict=''
  }  
}
  $host.ui.RawUI.WindowTitle = "$source$kind$sep$ar build ended $comment"
del $kind$sep$ar$restrict.started
exit
